from PyQt6.QtCore import QSysInfo


def maybe_crash():
    class StringHolder:

        value = None

        @classmethod
        def set_value(cls):
            # needs to be set here, setting from outside doesn't trigger the crash.
            # anything that returns a QString from Qt/C++
            cls.value = QSysInfo.productType()

    class StringHolderSub(StringHolder):

        # needs to be subclass, using StringHolder directly to access .value
        # doesn't trigger the crash.

        pass

    for _ in range(1010):  # triggers exactly after 1010 times.
        StringHolder.set_value()
        StringHolderSub.value


if __name__ == "__main__":
    for _ in range(5):
        # crash is not 100% reproducible with the minimal reproducer
        maybe_crash()
